﻿package com.alecdebusschere.src{
	
	import flash.display.*;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.EventDispatcher;
   	import flash.text.TextFieldAutoSize;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.geom.Matrix;
	import fl.transitions.Tween;
	import fl.transitions.easing.None;
	import fl.transitions.easing.Strong;
	import fl.transitions.TweenEvent;
	import flash.filters.BlurFilter;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import com.alecdebusschere.src.drawUtils.*;
	
	public class Global extends Sprite{
		
		//paths for data
		var datas:XmlData;
		
		var mainStage:Stage;
		var slider:SliderB;
		var structure:Structure;
		var frame:Shape;
		var navig:Object;
		
		public function Global(xmlPaths:Array, mainStage:Stage){
			this.datas = new XmlData(xmlPaths);
			this.mainStage = mainStage;
			this.datas.eventDispatcher.addEventListener("COMPLETE", function(){
																		
																		 initDraw();
																		 initEvents();
																		 });
			

		}
		
		private function initDraw(){
			structure = new Structure(datas.loadedXmls[0], datas.loadedXmls[1], mainStage);
			
			structure.x = this.mainStage.stageWidth/2;
			structure.y = this.mainStage.stageHeight/2;
			drawFrame();
			
			slider = new SliderB(this.mainStage.stageWidth, this.mainStage.stageHeight);
			
			drawNavig();
			
			addChild(structure);
			//addChild(this.frame);
			addChild(slider);
			addChild(navig.sprite);
		}
		private function drawNavig(){
			this.navig = new Object();
			this.navig.sprite = new Sprite();
			
			this.navig.leftArrow = new Triangle(Settings.navigArrowHeight, Settings.navigArrowWidth, 180, Settings.navigArrowBackgroundColor);
			this.navig.sprite.buttonMode = true;
			this.navig.leftArrow.x = this.navig.leftArrow.width/2+Settings.marginArrow;
			this.navig.leftArrow.y = this.mainStage.stageHeight/2;
			
			this.navig.rightArrow = new Triangle(Settings.navigArrowHeight, Settings.navigArrowWidth, 0, Settings.navigArrowBackgroundColor);
			this.navig.rightArrow.x = this.mainStage.stageWidth - this.navig.rightArrow.width/2 - Settings.marginArrow;
			this.navig.rightArrow.y = this.mainStage.stageHeight/2;
			
			this.navig.topArrow = new Triangle(Settings.navigArrowHeight, Settings.navigArrowWidth, 270, Settings.navigArrowBackgroundColor);
			
			this.navig.topArrow.x = this.mainStage.stageWidth/2;
			this.navig.topArrow.y = Settings.marginArrow+this.navig.topArrow.height/2;
			
			this.navig.bottomArrow = new Triangle(Settings.navigArrowHeight, Settings.navigArrowWidth, 90, Settings.navigArrowBackgroundColor);
			this.navig.bottomArrow.x = this.mainStage.stageWidth/2;
			this.navig.bottomArrow.y = this.mainStage.stageHeight-this.navig.bottomArrow.height/2-Settings.marginArrow;
			
			navig.sprite.addChild(this.navig.rightArrow);
			navig.sprite.addChild(this.navig.leftArrow);
			navig.sprite.addChild(this.navig.topArrow);
			navig.sprite.addChild(this.navig.bottomArrow);
			
		}
		private function drawFrame(){
			this.frame = new Shape();
			this.frame.graphics.beginFill(Settings.frameColor);
			this.frame.graphics.drawRect(0, 0, this.mainStage.stageWidth, Settings.frameWidth);
			this.frame.graphics.drawRect(this.mainStage.stageWidth-Settings.frameWidth, Settings.frameWidth, Settings.frameWidth, this.mainStage.stageHeight-Settings.frameWidth*2);
			
			this.frame.graphics.drawRect(0, Settings.frameWidth, Settings.frameWidth, this.mainStage.stageHeight);
			this.frame.graphics.drawRect(Settings.frameWidth, this.mainStage.stageHeight-Settings.frameWidth, this.mainStage.stageWidth-Settings.frameWidth, Settings.frameWidth);
		}
		
		private function initEvents(){
			
			for each(var w:Work in this.structure.works){
				w.addEventListener("click", function(e:MouseEvent){
													  //slider.updateKnob(Settings.maxRatio);													  //structure.gotoWork(e.target, mainStage.stageWidth, mainStage.stageHeight);
													  });
			}
			structure.addEventListener(MouseEvent.MOUSE_WHEEL, function(e:MouseEvent){
																	
																		slider.moveKnob(e.delta/3);//zoom by delta
																	
																		var destRatio:Number = slider.sliderManager.currentStep/Settings.sliderSteps*(Settings.maxRatio-Settings.minRatio)+Settings.minRatio;
																		structure.scalePoint.x = e.localX;
																		structure.scalePoint.y = e.localY;
																		structure.zoomTo(destRatio, mouseX, mouseY);
																		
																		
																		
																		
																		
																   });
			this.slider.addEventListener("SLIDER_MOVES", function(e:Object){
																		  //structure.resetTweens();
																		 // structure.translateTo(mainStage.stageWidth/2,mainStage.stageHeight/2);
																		  
																		  structure.zoomTo(e.data.step/Settings.sliderSteps*(Settings.maxRatio-Settings.minRatio)+Settings.minRatio, mainStage.stageWidth/2, mainStage.stageHeight/2);
																		  });
			
			this.navig.rightArrow.addEventListener("click", function(e:MouseEvent){
																				  structure.translateBy(-Settings.navigMove*structure.scaleX, 0);
																				  });
			this.navig.leftArrow.addEventListener("click", function(e:MouseEvent){
																				  structure.translateBy(Settings.navigMove*structure.scaleX, 0);
																				  });
			this.navig.topArrow.addEventListener("click", function(e:MouseEvent){
																				  structure.translateBy(0, Settings.navigMove*structure.scaleX);
																				  });
			this.navig.bottomArrow.addEventListener("click", function(e:MouseEvent){
																				  structure.translateBy(0, -Settings.navigMove*structure.scaleX);
																				  });			

		}
		
		
	}
		
}
