﻿package com.alecdebusschere.src{
	import flash.display.*;
	import flash.text.*;
	
	
	import flash.geom.*;

	
	internal class Work extends Sprite{
		
		//generic
		internal var workTitle:String;
		internal var id:int;
		
		//relations
		internal var rootW:Boolean = false;
		internal var parentW:Work;
		
		internal var children:Array = new Array();
		internal var categories:Array = new Array();
		internal var level:int;
		
		//geom data
		internal var angle:Number, diameter:int = Settings.wDiameter;
		internal var pos:Point = new Point();
		
		//display
		
		private var titleW:TextField = new TextField();
		private var titleContener:Sprite = new Sprite();
		private var circle:Shape;
		
		public function Work(id:int, workTitle:String, level:int, parent:Work){
			this.id = id;
			
			this.workTitle = workTitle;
			this.level = level;
			if(parent !=  null) this.parentW = parent;
			else this.rootW = true;
			
			this.titleW.embedFonts = true;
			this.titleW.autoSize = TextFieldAutoSize.LEFT;
          	this.titleW.antiAliasType = AntiAliasType.ADVANCED;
          	this.titleW.defaultTextFormat = Settings.formatWTitle;
			this.titleW.htmlText = "<i>"+workTitle+"</i>";
			
			this.buttonMode = true;

		}
		
		internal function setChildren(children:Array){
			this.children = children;
		}
		
		//GRAPHIC
		internal function setPos(levelDiameter:int, angle:int){
			this.angle = Math.PI * angle / 180;
			this.pos.x = Math.cos(this.angle) * ((levelDiameter*this.level)/2);
			this.pos.y = Math.sin(this.angle) * ((levelDiameter*this.level)/2);
		}
		
		internal function drawWork(){
			
			if(Settings.wStroke){
				graphics.lineStyle(Settings.wStrokeWeight, Settings.wStrokeColor, Settings.wStrokeAlpha);
				
				graphics.drawCircle(pos.x, pos.y, diameter/2);
				
			}
			
			
			for(var i:int = categories.length; i >= 1 ; i--){
				
				graphics.beginFill(this.categories[i-1].color);
				graphics.drawCircle(this.pos.x, this.pos.y, ((this.diameter/2)/(categories.length)*i)+this.diameter/10);
			}
			graphics.beginFill(0xFFFFFF);
			graphics.drawCircle(this.pos.x, this.pos.y, this.diameter/10);
			
			titleContener.x = this.pos.x+Math.cos(Settings.angleWTitle*Math.PI/180)*10;
			titleContener.y = (this.pos.y-this.titleW.height/2-3)+Math.sin(Settings.angleWTitle*Math.PI/180)*10;
			this.titleW.rotation = Settings.angleWTitle;
			
			titleContener.addChild(titleW);
			
			
			addChild(titleContener);
			
			
		}
		
	}
}